import React, { Component } from "react";
import PropTypes from "prop-types";

export default class Form extends Component {
	static contextTypes = {
		name: PropTypes.string,
		age: PropTypes.number,
		children: PropTypes.bool
	};

	componentDidMount() {
		console.log("this", this.context);
	}

	submit = () => {
		const { addToList } = this.props;
		addToList();
	};

	handleChange = e => {
		const { changeInputValue } = this.props;
		changeInputValue(e.target.value);
	};

	render() {
		const { inputData } = this.props;
		return (
			<div>
				<input type="text" value={inputData} onChange={this.handleChange} />
				<button type="submit" onClick={this.submit}>
					LETS GO
				</button>
			</div>
		);
	}
}
