import React, { Component } from "react";

import { Consumer } from "../../utils";

export default class List extends Component {
	static contextType = Consumer;

	change = ({ id, value }) => {
		const { changelistValue } = this.props;
		changelistValue({ id, value });
	};

	deleteItem = (e, id) => {
		e.stopPropagation();
		const { deleteItemList } = this.props;
		deleteItemList(id);
	};

	render() {
		const { list, toggleEditField } = this.props;
		console.log("sf", this.context);
		return (
			<div className="list">
				<ul className="list__ul">
					{list.map(el =>
						el.edit ? (
							<li className="list__item" key={el.id}>
								<input
									className="list__input"
									type="text"
									value={el.value}
									onChange={e => this.change({ id: el.id, value: e.target.value })}
								/>
								<button className="list__btn list__btn--edit" onClick={toggleEditField.bind(null, el.id)}>
									SAVE MEEEEE
								</button>
							</li>
						) : (
							<li className="list__item" onClick={toggleEditField.bind(null, el.id)} key={el.id}>
								{el.value}
								<button className="list__btn list__btn--remove" onClick={e => this.deleteItem(e, el.id)}>
									x
								</button>
							</li>
						)
					)}
				</ul>
			</div>
		);
	}
}
