import React, { Component } from "react";
import { string, number, bool } from "prop-types";
import { bindActionCreators } from "redux";
import { connect } from "react-redux";

import Page from "../components/page";
import * as actions from "../actions/todo";

class App extends Component {
	constructor(props) {
		super(props);
		this.state = {
			name: "tony",
			age: 26,
			children: false
		};

		console.log("constructor");
	}

	componentDidMount() {
		console.log("componentDidMount");
	}

	componentDidUpdate(prevProps, prevState, prevContext) {
		if (this.props.error && !prevProps.error) console.log("componentDidUpdate");
	}

	shouldComponentUpdate(nextProp, nextState, nextContext) {
		console.log("shouldComponentUpdate");
		return true;
	}

	componentWillUnmount() {
		console.log("componentWillUnmount");
	}

	static childContextTypes = {
		name: string,
		age: number,
		children: bool
	};

	getChildContext() {
		const { name, age, children } = this.state;
		return {
			name,
			age,
			children
		};
	}

	render() {
		console.log("render", this.props);
		return (
			<div className="container">
				<Page {...this.props} />
			</div>
		);
	}
}

const mapStateToProps = state => ({
	inputData: state.todo.inputData,
	list: state.todo.list
});

const mapDispatchToProps = dispatch => bindActionCreators({ ...actions }, dispatch);

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(App);
