import React, { Component } from "react";
import { connect } from "react-redux";
import { bindActionCreators } from "redux";

import { takeInputValue, getWeather } from "../actions/weather";
import Add from "../components/weather";
import { Provider } from "../utils";

class FetchPage extends Component {
	state = {
		foo: 1
	};

	add = () => this.setState(prevState => ({ foo: prevState.foo + 1 }));

	change = e => {
		const { takeInputValue } = this.props;
		takeInputValue(e.target.value);
	};

	click = () => {
		const { city, getWeather } = this.props;
		getWeather(city);
	};

	render() {
		const { weather, error } = this.props;
		console.log("weather", weather);
		return (
			<div className="page">
				<Provider value={weather}>
					<input className="page__input page__input--blue" type="text" onChange={this.change} />
					<button className="page__button" onClick={this.click}>
						SHOW
					</button>

					<div>{weather && weather.location && weather.location.city}</div>
					<div>{error && error}</div>

					<Add />

					<button onClick={this.add}>PUSH ME</button>
				</Provider>
			</div>
		);
	}
}

const mapStateToProps = state => ({
	city: state.w.city,
	weather: state.w.weather,
	error: state.w.error
});

const mapDispatchToProps = dispatch => bindActionCreators({ takeInputValue, getWeather }, dispatch);

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(FetchPage);
